- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# bigip_software_image – Manage software images on a BIG-IP

New in version 2.7.

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Manages software images on a BIG-IP. These images may include both base images and hotfix images.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
force boolean | Choices: no ← yes | When `yes`, will upload the file every time and replace the file on the device. When `no`, the file will only be uploaded if it does not already exist. Generally should be `yes` only in cases where you have reason to believe that the image was corrupted during upload.
image string |  | The image to put on the remote device. This may be an absolute or relative location on the Ansible controller. Image names, whether they are base ISOs or hotfix ISOs, must be unique.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| transport string | Choices: cli rest ← | Configures the transport connection to use when connecting to the remote device.
| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.
| validate_certs boolean | Choices: no yes ← | If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates. You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.
state string | Choices: absent present ← | When `present`, ensures that the image is uploaded. When `absent`, ensures that the image is removed.

## Notes

Note

- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.

- Requires BIG-IP software version >= 12.

- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Upload relative image to the BIG-IP
      bigip_software_image:
        image: BIGIP-13.0.0.0.0.1645.iso
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

    - name: Upload absolute image to the BIG-IP
      bigip_software_image:
        image: /path/to/images/BIGIP-13.0.0.0.0.1645.iso
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

    - name: Upload image in a role to the BIG-IP
      bigip_software_image:
        image: "{{ role_path }}/files/BIGIP-13.0.0.0.0.1645.iso"
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
build string | changed | Build version of the software contained in the image. Sample: 0.0.3
checksum string | changed | MD5 checksum of the ISO. Sample: 8cdbd094195fab4b2b47ff4285577b70
file_size integer | changed | Size of the uploaded image in MB. Sample: 1948
image_type string | changed | Whether the image is a release or hotfix image Sample: release
version string | changed | Version of the software contained in the image. Sample: 13.1.0.8

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.